Request

Response

    Scope-Specific Bid Forms
    POST

    scope-specific-bid-forms/{formId}/line-items

    Creates a scope-specific bid form line item.

    Note that a bid form’s line items must each have a unique combination of the type, description, and section field values.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms/{formId}/line-items
    Authentication Context
    User context required
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    Content-Type*
    string
    Must be application/json
    * Required

    Request

    URI Parameters

    formId
    string
    The ID of the form.

    Request

    Body Structure

    Expand all
    type*
    enum:string
    The type of the scope-specific bid form line item.

    The possible values have the following UI equivalents:

    • ADDENDUM — Scope-Specific Information and Unit Costs
    • ALTERNATE — Alternates
    • COST_BREAKDOWN — Line Items
    • INCLUSION — Inclusions
    • SCOPE_CLARIFICATION — Scope-Specific Clarifications
    description*
    string
    A description of the scope-specific bid form line item.
    section
    string
    The user-defined name of an optional section of the scope-specific bid form that the line item is in. If the section does not exist, a new section is created automatically. This value should be null if the item is not in a section.

    Note that all of the line items for which you provide the same section value will be in the same section.

    isRequired
    boolean
    Indicates whether the scope-specific line item is required in bids. Possible values:
    • true: The scope-specific line item is required.
    • false: The scope-specific line item is optional.
    unit
    enum:string
    The unit format of the scope-specific line item.

    The possible values of this field depend on the value of type. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • ADDENDUM — TEXT, YES_NO, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, TOTAL_COST_ONLY
    • ALTERNATE — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • BONDING — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • CERTIFICATION — TEXT, YES_NO
    • COST_BREAKDOWN — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • DISCLAIMER — Converted to null
    • INCLUSION — YES_NO_WITH_ADJUSTMENT
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY
    • SCOPE_CLARIFICATION — Converted to null

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    The cost code associated with the scope-specific line item.

    Max length: 87

    quantity
    number
    The quantity of the scope-specific line item. This value is null under either of the following conditions:
    • The value of type is not COST_BREAKDOWN. Only COST_BREAKDOWN type items have a quantity.
    • The value of unit is TOTAL_COST_ONLY. Items with a TOTAL_COST_ONLY unit do not have a quantity.
    isQuantityFixed
    boolean
    Indicates whether the scope-specific line item quantity is fixed. If it is fixed, bidders cannot change it. Possible values:
    • true: The scope-specific line item quantity is fixed.
    • false: The scope-specific line item quantity can be changed by bidders.
    external
    object
    Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.

    Note that BuildingConnected does not use the information in this object.

    id*
    string
    A user-provided ID of the external tool.
    name
    string
    A user-provided name for the external tool.
    * Required

    Response

    HTTP Status Code Summary

    201
    Created
    Created
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Header (201)

    Location
    string
    The created resource’s location.

    Response

    Body Structure (201)

    Expand all
    id
    string
    The unique ID of the scope-specific line item.

    Max length: 24

    type
    enum:string
    The type of the scope-specific line item.

    The possible values have the following UI equivalents:

    • ADDENDUM — Scope-Specific Information and Unit Costs
    • ALTERNATE — Alternates
    • COST_BREAKDOWN — Line Items
    • INCLUSION — Inclusions
    • SCOPE_CLARIFICATION — Scope-Specific Clarifications
    description
    string
    A description of the scope-specific line item.
    section
    string
    The section that the scope-specific line item is under. This value is null if the item is not under a section.
    isRequired
    boolean
    Indicates whether the scope-specific line item is required. Possible values:
    • true: The scope-specific line item is required.
    • false: The scope-specific line item is optional.
    unit
    enum:string
    The unit format of the scope-specific line item.

    The possible values of this field depend on the value of type. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • ADDENDUM — TEXT, YES_NO, PER_ACRE, PER_AMP, PER_BOARD_FT, PER_CUBIC_FT, PER_CUBIC_METER, PER_CUBIC_YARD, PER_DAY, PER_EACH, PER_FLOOR, PER_GALLON, PER_GROSS_SQUARE_FT, PER_GROSS_SQUARE_METER, PER_HOUR, PER_KILOGRAM, PER_LINEAR_FT, PER_LINEAR_METER, PER_LINEAR_YARD, PER_LITER, PER_LOT, PER_METRIC_TON, PER_MONTH, PER_POUND, PER_RISER, PER_SQUARE_FT, PER_SQUARE_METER, PER_SQUARE_YARD, PER_SQUARE_YARD_INCH, PER_STALL, PER_STOP, PER_TON, PER_WATT, PER_WEEK, TOTAL_COST_ONLY
    • ALTERNATE — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TEXT, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • BONDING — YES_NO, TOTAL_COST_ONLY, TEXT, PERCENTAGE
    • CERTIFICATION — TEXT, YES_NO
    • COST_BREAKDOWN — ACRES, AMPS, BOARD_FT, CUBIC_FT, CUBIC_METERS, CUBIC_YARDS, DAYS, EACH, FLOORS, GALLONS, GROSS_SQUARE_FT, GROSS_SQUARE_METERS, HOURS, KILOGRAMS, LINEAR_FT, LINEAR_METERS, LINEAR_YARDS, LITERS, LOT, METRIC_TONS, MONTHS, POUNDS, RISERS, SQUARE_FT, SQUARE_METERS, SQUARE_YARDS, SQUARE_YARD_INCHES, STALLS, STOPS, TONS, TOTAL_COST_ONLY, WATTS, WEEKS
    • DISCLAIMER — Converted to null
    • INCLUSION — YES_NO_WITH_ADJUSTMENT
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY
    • SCOPE_CLARIFICATION — Converted to null

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    The cost code associated with the scope-specific line item.
    quantity
    number
    The quantity of the scope-specific line item. This value is null under either of the following conditions:
    • The value of type is not COST_BREAKDOWN. Only COST_BREAKDOWN type items have a quantity.
    • The value of unit is TOTAL_COST_ONLY. Items with a TOTAL_COST_ONLY unit do not have a quantity.
    isQuantityFixed
    boolean
    Indicates whether the scope-specific line item quantity is fixed. If it is fixed, bidders cannot change it. Possible values:
    • true: The scope-specific line item quantity is fixed.
    • false: The scope-specific line item quantity can be changed by bidders.
    external
    object
    Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.

    Note that BuildingConnected does not use information in this object.

    id
    string
    The ID of the external tool.
    name
    string
    The name of the external tool.

    Example

    Created

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/scope-specific-bid-forms/:formId/line-items' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "type": "COST_BREAKDOWN",
            "description": "Duct Insulation",
            "section": "Furnish & Install",
            "isRequired": true,
            "unit": "HOURS",
            "code": "D2",
            "quantity": 1000,
            "isQuantityFixed": true,
            "external": {
              "id": "ext-cost-id-123",
              "name": "External Cost Code"
            }
          }'
    
    Show More

    Response

    {
      "id": "53811754d3a604966df72247",
      "type": "COST_BREAKDOWN",
      "description": "Duct Insulation",
      "section": "Furnish & Install",
      "isRequired": true,
      "unit": "HOURS",
      "code": "D2",
      "quantity": 1000,
      "isQuantityFixed": true,
      "external": {
        "id": "ext-cost-id-123",
        "name": "External Cost Code"
      }
    }
    
    Show More